<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: CMDRSCHAINEDLIST&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classCMDRSCHAINEDLIST.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classCMDRSCHAINEDLIST-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CMDRSCHAINEDLIST&lt; T &gt; Class Template Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>&quot;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6a8536f2cb62714624e8a1ae2c021191"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMDRSCHAINEDLIST.html#a6a8536f2cb62714624e8a1ae2c021191">CMDRSCHAINEDLIST</a> ()</td></tr>
<tr class="separator:a6a8536f2cb62714624e8a1ae2c021191"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9376873ee15cd2ad4f239b832c700c56"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMDRSCHAINEDLIST.html#a9376873ee15cd2ad4f239b832c700c56">AddItem</a> (T *inpt)</td></tr>
<tr class="separator:a9376873ee15cd2ad4f239b832c700c56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c95325c818d2e63d6ccf0b7f5250103"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMDRSCHAINEDLIST.html#a7c95325c818d2e63d6ccf0b7f5250103">NextCurrent</a> ()</td></tr>
<tr class="separator:a7c95325c818d2e63d6ccf0b7f5250103"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a604e8c770db9bc2a7b11fa2aacc56993"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMDRSCHAINEDLIST.html#a604e8c770db9bc2a7b11fa2aacc56993">pFirst</a></td></tr>
<tr class="separator:a604e8c770db9bc2a7b11fa2aacc56993"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae382ce65496e09ba16dfa0fc6f311a27"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCMDRSCHAINEDLIST.html#ae382ce65496e09ba16dfa0fc6f311a27">pCurrentItem</a></td></tr>
<tr class="separator:ae382ce65496e09ba16dfa0fc6f311a27"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class CMDRSCHAINEDLIST&lt; T &gt;</h3>

<p>This class describes a chained list of items (<a href="https://en.wikipedia.org/wiki/Linked_list">https://en.wikipedia.org/wiki/Linked_list</a>). It can be called also a linked list. This is an elegant way to build a list without any big allocation, bypassing the needs to estimate a minimum size and to increase or decrease this size during execution. The disavantage is a slower and more complex way to access to an item on the list, and a more complex way to add a new item.</p>
<p>To start, a chained list needs a starting pointer referencing the first item of the list. After that, each item have a pointer to the next item. If this pointer is NULL, this is the end of the list !</p>
<p>The 'T' type can be of any type, including base types like int or char. But keep in mind that each item must save a pointer to the next item. If the size of the pointer is greater than the size of the item itself, consider using a true array...</p>
<p>A notion of 'current item' is used, to let the user of the list to move through the list without doing a loop itself... </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00033">33</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a6a8536f2cb62714624e8a1ae2c021191"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">CMDRSCHAINEDLIST&lt; T &gt;::CMDRSCHAINEDLIST </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00042">42</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a9376873ee15cd2ad4f239b832c700c56"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void CMDRSCHAINEDLIST&lt; T &gt;::AddItem </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>inpt</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a new item to the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inpt</td><td>Address of the item to add. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00061">61</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7c95325c818d2e63d6ccf0b7f5250103"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void CMDRSCHAINEDLIST&lt; T &gt;::NextCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Move the current pointer to the next one in the list. If the current was the last one, the current pointer will be set to the start of the list, its first item. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00085">85</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="ae382ce65496e09ba16dfa0fc6f311a27"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a>&lt;T&gt;* CMDRSCHAINEDLIST&lt; T &gt;::pCurrentItem</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Address of current item in the chain, or NULL for none. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00039">39</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a604e8c770db9bc2a7b11fa2aacc56993"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCMDRSCHAINEDLISTITEM.html">CMDRSCHAINEDLISTITEM</a>&lt;T&gt;* CMDRSCHAINEDLIST&lt; T &gt;::pFirst</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Address of next element in chain, or NULL for none. In this case the list is empty. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00037">37</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="Chain_8hpp_source.html">Chain.hpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
